.Data
;mp recover
MP_normal	dd 0041FB88h
MP_hack 	dd 0041FBA8h
;opoint HP
Max_HP1		dd 004202A2h
Max_HP2		dd 004202D3h
;hiding shadow
hs_r1		dd 0041A810h
hs_r2		dd 0041A794h
;itr effect
ef_r1		dd 0042EBEAh
ef_r2		dd 0042ED3Dh
ef_r3		dd 0042EC13h
ie_r1		dd 0042FD8Bh
ie_r2		dd 0042FDEDh

.Code
Health proc
	
	MOV ECX,DWORD PTR DS:[EBX+EDI*4h+194h] ;ignore this
	MOV EDX,DWORD PTR DS:[ECX+368h] ; ignore this
	MOV EDX,DWORD PTR DS:[EDX+6F4h] ; ignore this
	cmp edx,55 ; check if ID is 55
	je short @HP_check_1 ;if it's not 55 then jump to normal procedure
	cmp edx,20
	je short @HP_check_3
	jmp short @HP_normal ;otherwise just recover hp normally
	
	@HP_check_1:
	cmp dword ptr ds:[eax+300h],250 ; compare dark red with 250
	jl short @HP_LowDarkRed_1 ; if its lower than jump to LowDarkRed
	cmp dword ptr ds:[eax+2fch],250 ; compare red hp with 250
	jl short @HP_LowRed_1 ; if its lower then jump to LowRed
	jmp short @HP_normal ;otherwise just recover hp normally
	@HP_LowDarkRed_1:
	add dword ptr ds:[eax+300h],5 ; add 5 to dark red hp
	@HP_LowRed_1:
	add DWORD PTR DS:[EAX+2FCh],4 ; add 4 to red hp
	retn
	
	@HP_check_3:
	;cmp dword ptr ds:[eax+300h],121
	;jle short @HP_LowDarkRed_3a
	cmp dword ptr ds:[eax+300h],124
	jle short @HP_LowDarkRed_3b
	cmp dword ptr ds:[eax+2fch],121
	jle short @HP_LowRed_3a
	;cmp dword ptr ds:[eax+2fch],124
	;jle short @HP_LowRed_3b
	jmp short @HP_normal
	;@HP_LowDarkRed_3a:
	;add dword ptr ds:[eax+300h],4
	@HP_LowRed_3a:
	add DWORD PTR DS:[EAX+2FCh],4
	retn	
	@HP_LowDarkRed_3b:
	add dword ptr ds:[eax+300h],1
	;@HP_LowRed_3b:
	add DWORD PTR DS:[EAX+2FCh],1
	retn
	
	@HP_normal:
	add DWORD PTR DS:[EAX+2FCh],1 ; add 1 to
	retn

Health endp

MP proc
	
	cmp edx,51 ; check if ID is 51 (Firzen)
	je short @MP_1 ; jump to @MP_1 if ID is 51
	cmp edx,52 ; check if ID is 52 (Julian)
	je short @MP_1 ; jump to @MP_1 if ID is 52
	cmp edx,55 ; check if ID is 55 (your character)
	je short @MP_2 ; jump to @MP_2 if ID is 55
	jmp dword ptr [MP_normal]
	
	@MP_1: ; for Firzen & Julian
	cdq ; ignore this
	sub eax,edx  ; ignore this
	sar eax,1 ; add 1 point more compare with normal (normal = 1)
	jmp dword ptr [MP_normal]
	
	@MP_2: ; for the ID 55
	cmp dword ptr ds:[ecx+308h],250 ; check if mp is greater than 250
	JG @Decrease_MP
	cdq ; ignore this
	sub eax,edx ; ignore this
	sar eax,2 ; add 2 point more compare with normal
	jmp dword ptr [MP_normal]
	
	@Decrease_MP: ;when mp is more than 250
	mov eax, dword ptr ds:[ecx+308h] ; move mana into eax
	sub eax,1 ; decrease eax(mana) by 1
	jmp dword ptr [MP_hack]

MP endp

Max_HP proc
	
	cmp ecx,5 ; Check if ID is 5 (Rudolf)
	je short HP_10 ; go to the 10 HP part
	cmp ecx,52 ; Check if ID is 5 (Julian)
	je short HP_10 ; go to the 10 HP part
	cmp ecx,55 ; Put your character or object's ID here
	je short HP_125 ; go to the 125 HP part
	jmp dword ptr [Max_HP2]
	
	HP_10:
	mov ecx,10 ; 10 HP for Rudolf's Double and Julian's Mirror Image
	jmp dword ptr [Max_HP1]
	
	HP_125:
	mov ecx,125 ; 125 HP if you spawn your character or object (normal = 500)
	jmp dword ptr [Max_HP1]	

Max_HP endp

Hide_shadow proc
	
	cmp eax,0DFh
	je short r1
	;cmp eax,ID
	;je short r1
	jmp dword ptr [hs_r2]
r1:	jmp dword ptr [hs_r1]

Hide_shadow endp

itr_effect_fall proc
	
	mov eax,dword ptr ss:[esp+0Ch]
	mov eax,dword ptr ds:[eax+2Ch]
	cmp eax,7
	je short no_injure
	cmp eax,8
	je short fall
	mov eax,dword ptr ds:[esi+edi*4+194h]
	jmp dword ptr [ef_r1]
r3:	jmp dword ptr [ef_r3]
	
no_injure:
	mov eax,dword ptr ds:[esi+edi*4+194h]
	mov edx,dword ptr ds:[eax+368h]
	cmp dword ptr ds:[edx+6F8h],3
	je short r3
	jmp dword ptr [ef_r2]
	
fall:
	mov eax,dword ptr ds:[esi+edi*4+194h]
	mov edx,dword ptr ds:[eax+368h]
	cmp dword ptr ds:[edx+6F8h],3
	je short r3
	mov dword ptr ds:[eax+0B0h],50h
	jmp dword ptr [ef_r2]

itr_effect_fall endp

itr_effect proc
	
	cmp eax,3
	je short r1
	cmp eax,6
	je e6
	cmp eax,6000
	jge short ie0
r2:	jmp dword ptr [ie_r2]
r1:	jmp dword ptr [ie_r1]
ie0:cmp eax,6400
	jl short frame
	cmp eax,8000
	jl short r2
	cmp eax,9000
	jl short transform
	cmp eax,1000000000
	jl short r2
	cmp eax,1400000000
	jl general	
	cmp eax,1999000000
	jl short r2
	cmp eax,2000000000
	jl general
	jmp short r2

frame:
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov edx,dword ptr ds:[ecx+368h]
	cmp dword ptr ds:[edx+6F8h],0
	jnz short r2
	mov ecx,dword ptr ds:[ecx+78h]
	imul ecx,ecx,178
	cmp dword ptr ds:[ecx+edx+7ACh],eax
	je short r2
	sub eax,6000
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov dword ptr ds:[ecx+70h],eax
	jmp short r2
	
transform:
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov edx,dword ptr ds:[ecx+368h]
	cmp dword ptr ds:[edx+6F8h],0
	jnz r2
	mov ecx,dword ptr ds:[ecx+78h]
	imul ecx,ecx,178
	cmp dword ptr ds:[ecx+edx+7ACh],80
	je r2
	sub eax,8000
	cmp dword ptr ds:[edx+6F4h],eax
	je r2
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov dword ptr ds:[ecx+70h],0
	push ebx
	push esi
	add eax,4000
	mov ebx,esi
	mov ecx,dword ptr ds:[ebx+edi*4+194h]
	mov edx,dword ptr ds:[ecx+368h]
	MOV ECX,DWORD PTR DS:[EBX+7D4h]
	LEA EDX,DWORD PTR DS:[EAX-0FA0h]
	XOR EAX,EAX
	CMP DWORD PTR DS:[ECX+4D82380h],EAX
	JLE short a
d:	MOV ESI,DWORD PTR DS:[ECX]
	CMP DWORD PTR DS:[ESI+6F4h],EDX
	JE short b
	MOV ESI,DWORD PTR DS:[EBX+7D4h]
	ADD EAX,1
	ADD ECX,4
	CMP EAX,DWORD PTR DS:[ESI+4D82380h]
	JL short d
	JMP short a
b:	MOV ECX,DWORD PTR DS:[EBX+7D4h]
	MOV ECX,DWORD PTR DS:[ECX+EAX*4h]
	MOV EAX,DWORD PTR DS:[EBX+EDI*4+194h]
	MOV DWORD PTR DS:[EAX+368h],ECX
a:	pop esi
	pop ebx
	jmp r2
	
general:
	push ebx
	mov edx,0
	mov ebx,1000000
	idiv ebx
	sub eax,1000
	push eax
	mov eax,edx
	mov edx,0
	mov ebx,1000
	idiv ebx
	push eax
	push edx
	
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov edx,dword ptr ds:[ecx+368h]
	cmp dword ptr ds:[edx+6F8h],0
	jnz g1
	mov ecx,dword ptr ds:[ecx+78h]
	imul ecx,ecx,178
	pop eax
	cmp eax,999
	je short g4
	cmp eax,998
	je g5
	cmp dword ptr ds:[ecx+edx+7ACh],eax
	jnz g2
	
g4:	pop eax
	cmp eax,999
	je g3
	cmp dword ptr ds:[edx+6F4h],eax
	je g3
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov edx,dword ptr ds:[ecx+70h]
	push edx
	mov dword ptr ds:[ecx+70h],0
	add eax,4000
	mov ebx,esi
	mov ecx,dword ptr ds:[ebx+edi*4+194h]
	mov edx,dword ptr ds:[ecx+368h]
	MOV ECX,DWORD PTR DS:[EBX+7D4h]
	LEA EDX,DWORD PTR DS:[EAX-0FA0h]
	XOR EAX,EAX
	CMP DWORD PTR DS:[ECX+4D82380h],EAX
	JLE short ga
gd:	MOV ESI,DWORD PTR DS:[ECX]
	CMP DWORD PTR DS:[ESI+6F4h],EDX
	JE short gb
	MOV ESI,DWORD PTR DS:[EBX+7D4h]
	ADD EAX,1
	ADD ECX,4
	CMP EAX,DWORD PTR DS:[ESI+4D82380h]
	JL short gd
	JMP short ga
gb:	MOV ECX,DWORD PTR DS:[EBX+7D4h]
	MOV ECX,DWORD PTR DS:[ECX+EAX*4h]
	MOV EAX,DWORD PTR DS:[EBX+EDI*4+194h]
	MOV DWORD PTR DS:[EAX+368h],ECX
ga:	mov esi,ebx
	pop edx
	
	pop eax
	cmp eax,999
	je short g7
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov dword ptr ds:[ecx+70h],eax
	jmp short g6
g7:	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov dword ptr ds:[ecx+70h],edx
g6:	pop ebx
	jmp r2
	
	
g5:	cmp dword ptr ds:[ecx+edx+7ACh],11
	je g4
	cmp dword ptr ds:[ecx+edx+7ACh],16
	je g4
	jmp short g2
	
g1:	add esp,4
g2:	add esp,4
g3:	add esp,4
	pop ebx
	jmp r2
	
e6:	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov edx,dword ptr ds:[ecx+368h]
	cmp dword ptr ds:[edx+6F8h],0
	jnz r2
	mov ecx,dword ptr ds:[ecx+78h]
	imul ecx,ecx,178
	cmp dword ptr ds:[ecx+edx+7ACh],150
	je r2
	mov ecx,dword ptr ds:[esi+edi*4+194h]
	mov dword ptr ds:[ecx+70h],150
	jmp r2
	

itr_effect endp